import App
import MissionLib

pGame = App.Game_GetCurrentGame()
pEpisode = pGame.GetCurrentEpisode()
pMission = pEpisode.GetCurrentMission()

g_pMissionDatabase 	= None
g_pFelix	= None
g_pBrex		= None
	
################################################################################
##	TractorTargetDocked()
##
##	Event handler called when tractor target has docked with ship.
##
##	Args:	pTGObject	- The TGObject object
##			pEvent		- The event that was sent to the object
##
##	Return:	None
################################################################################
# Defiant....
def TractorTargetDocked(pTGObject, pEvent):
	print("Calling TractorTargetDocked()")

	# Get some Var for the Audio Lines
	global g_pMissionDatabase
	global g_pFelix
	pBridge = App.g_kSetManager.GetSet("bridge")
	g_pMissionDatabase 	= pMission.SetDatabase("data/TGL/Maelstrom/Episode 6/E6M2.tgl")
	g_pFelix	= App.CharacterClass_GetObject(pBridge, "Tactical")

	# Get the object that was docked and it's name
	pObject	= App.ShipClass_Cast(pEvent.GetObjPtr())
	if (pObject == None):
		return
	pShip	= App.ShipClass_Cast(pEvent.GetDestination())
	if (pShip == None):
		return
	sShipName	= pShip.GetName()
	sName 	= pObject.GetName()

	# If the object is a escape pod, remove it from the set
	# and increase the captured count
	print("Object name is: " + sName)
	if (sName[:3] == "Ret"):
		pObject.SetDeleteMe(1)
		
		if (sShipName == "Player"):
			print("Play the audio line that will let the player know pod is docked")
			pSequence = App.TGSequence_Create()
			pFelixLine	= App.CharacterAction_Create(g_pFelix, App.CharacterAction.AT_SAY_LINE, "E6M2PodDocked", "Captain", 1, g_pMissionDatabase)
			pSequence.AppendAction(pFelixLine, 2) #2 second delay
			pSequence.Play() 
			
	elif (sName[:7] == "Shuttle"):
		pObject.SetDeleteMe(1)
		
		print("Tractor Target Docked is finished and done")

################################################################################
##	TractorBeamOn()
##
##	Event handler called when tractor beam starts hitting a target.  Checks to
##	see if the target is a pod and starts docking behavior if it is.
##
##	Args:	TGObject	- The TGObject object.
##			pEvent		- The event that was sent.
##
##	Return:	None
################################################################################
#Defiant...
def TractorBeamOn(TGObject, pEvent):
	# Get the event destination (the thing hit by tractor beam)
	print("Tractor Beam on")

	# Get some Var for the Audio Lines
	global g_pMissionDatabase
	global g_pFelix
	global g_pBrex
	pBridge = App.g_kSetManager.GetSet("bridge")
	g_pMissionDatabase 	= pMission.SetDatabase("data/TGL/Maelstrom/Episode 6/E6M2.tgl")
	g_pFelix	= App.CharacterClass_GetObject(pBridge, "Tactical")
	g_pBrex		= App.CharacterClass_GetObject(pBridge, "Engineer")
	
	pShip = App.ShipClass_Cast(pEvent.GetDestination())
	if (pShip == None):
		print("failed")
		return
		
	sTargetName = pShip.GetName()
	print("Target Ship in Tractor is: " + sTargetName)
	
	# Get the tractor beam system that fired so we
	# can set it's behavior.
	pTractorProjector	= App.TractorBeamProjector_Cast(pEvent.GetSource())
	pTractorSystem		= App.TractorBeamSystem_Cast(pTractorProjector.GetParentSubsystem())
	
	# Get the name of the ship that fired
	pShip = pTractorSystem.GetParentShip()
	if (pShip == None):
		return
	sFiringShipName = pShip.GetName()
		
	# See if it's an escape pod
	global g_fLastCheckTime
	fStartTime = App.g_kUtopiaModule.GetGameTime()	
	
	if (sTargetName[:3] == "Ret"):
		print("Its an escape Pod")
		# If their using the forward tractor, tell them
		# it won't work and bail out
		pProp = pTractorProjector.GetProperty()
		if (pProp.GetWeaponID() == 1):
			if (g_fLastCheckTime + 5 < fStartTime): 
				g_fLastCheckTime = fStartTime
				pFelixLine	= App.CharacterAction_Create(g_pFelix, App.CharacterAction.AT_SAY_LINE, "E6M2WrongTractorBeam", "Captain", 1, g_pMissionDatabase)
				pFelixLine.Play()
			return

		# It's a pod so start our docking behavior and have Felix
		# say his line
		if (pTractorSystem != None):
			# set the tractor beam to pull in and dock the pod
			pTractorSystem.SetMode(pTractorSystem.TBS_DOCK_STAGE_1)
			# If the ship that's firing is the player, then
			# play Felix's line, and remove the name of the pod
			# from our list so this audio doesn't repeat
			pPlayer = MissionLib.GetPlayer()
			if (pPlayer == None):
				return
			if(sFiringShipName == pPlayer.GetName()):
				print("Player is firing their tractor beam on a pod")
				# play the line
				print("Playing Brex's .attempting to dock pod. line")	
				pBrexLine = App.CharacterAction_Create(g_pBrex, App.CharacterAction.AT_SAY_LINE, "E6M2FelixDockPod", "Captain", 1, g_pMissionDatabase)
				pBrexLine.Play()
	elif (sTargetName[:7] == "Shuttle"):
		print("Its a Shuttle")
		# If their using the forward tractor, tell them
		# it won't work and bail out
		pProp = pTractorProjector.GetProperty()
		if (pProp.GetWeaponID() == 1):
			if (g_fLastCheckTime + 5 < fStartTime): 
				g_fLastCheckTime = fStartTime
				pFelixLine	= App.CharacterAction_Create(g_pFelix, App.CharacterAction.AT_SAY_LINE, "E6M2WrongTractorBeam", "Captain", 1, g_pMissionDatabase)
				pFelixLine.Play()
			return

		# It's a pod so start our docking behavior and have Felix
		# say his line
		if (pTractorSystem != None):
			# set the tractor beam to pull in and dock the pod
			pTractorSystem.SetMode(pTractorSystem.TBS_DOCK_STAGE_1)

	# We're done.  Let any other handlers for this event handle it.
	print("Tractor beam on finished")
	TGObject.CallNextHandler(pEvent)
	

print("Loading Defiants event Handlers to get the Shuttles back")
# Tractor beam target docked event
App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_TRACTOR_TARGET_DOCKED, pMission, __name__+".TractorTargetDocked")
# Tractor beam starts hitting event
App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_TRACTOR_BEAM_STARTED_HITTING, pMission, __name__+".TractorBeamOn")
